package robot

import (
	"go_dreamfactory/comm"
	"go_dreamfactory/modules/hero"
	"go_dreamfactory/pb"
)

var (
	//hero
	heroBuilders = []*builder{
		{
			mainType: string(comm.ModuleHero),
			subType:  hero.HeroSubTypeList,
			req:      &pb.HeroListReq{},
			rsp:      &pb.HeroListRsp{},
			// enabled:  true,
		}, {
			mainType: string(comm.ModuleHero),
			subType:  hero.HeroSubTypeInfo,
			req: &pb.HeroInfoReq{
				HeroId: "62baac19aa7c09b3679be57c",
			},
			rsp: &pb.HeroInfoRsp{},
			// enabled: true,
		}, {
			mainType: string(comm.ModuleHero),
			subType:  hero.HeroSubTypeChouka,
			req:      &pb.HeroChoukaReq{},
			rsp:      &pb.HeroChoukaResp{},
			enabled:  true,
		},
	}
)

//声明加入到构建器并发起请求
func (r *Robot) RunHero() {
	r.addBuilders(heroBuilders)
	r.handleReq()
}
