# Robot使用

## 命令行

```sh
#使用已存在的账号测试接口
go run cmd.go run --account yourAccount
```

```sh
#使用新账号测试接口
go run cmd.go run --account newAccount --create true
```

@[TOC]

### 添加测试接口

* 声明测试接口

```go
var user_builders = []*builder{
 {
  //create
  mainType: string(comm.SM_UserModule),
  subType:  user.User_SubType_Create,
  req: &pb.UserCreateReq{ //设置请求参数
   NickName: "测试",
  },
  rsp:     &pb.UserCreateRsp{},
  enabled: true,
 },
}
```

### 声明加入到构建器并发起请求

```go
func (r *Robot) RunUser() {
 r.addBuilders(user_builders)
 r.handleReq()
}
```

### 添加用户登录之后需要测试的接口

```go
func (r *Robot) onUserLoaded() {
 //添加用户登录之后需要测试的接口
 r.RunUser()
}
```
