package cbase

import (
	"go_dreamfactory/lego/core"
)

//模块基础组件
type ModuleCompBase struct{}

//模块基础组件 初始化接口 组件可以通过此接口 获取到当前运行的服务对象以及组件的所属模块对象和上层组件的实现对象以及 模块的配置参数对象
func (this *ModuleCompBase) Init(service core.IService, module core.IModule, comp core.IModuleComp, options core.IModuleOptions) (err error) {
	return
}

//组件启动接口
func (this *ModuleCompBase) Start() (err error) {
	return
}

//组件销毁接口
func (this *ModuleCompBase) Destroy() (err error) {
	return
}
