package cbase

import (
	"go_dreamfactory/lego/core"
)

//服务基础组件
type ServiceCompBase struct {
}

//组件参数对象 更具服务组件的需求 可以重构此接口实现自定义参数对象的返回
func (this *ServiceCompBase) NewOptions() (options core.ICompOptions) {
	return new(ServiceCompOptions)
}

//组件初始化接口对象
func (this *ServiceCompBase) Init(service core.IService, comp core.IServiceComp, options core.ICompOptions) (err error) {
	return
}

//组件启动接口
func (this *ServiceCompBase) Start() (err error) {
	return
}

//组件销毁接口
func (this *ServiceCompBase) Destroy() (err error) {
	return
}
