package forum

import (
	"go_dreamfactory/comm"
	"go_dreamfactory/lego/core"
	"go_dreamfactory/modules"
)

/*
模块名:论坛
描述:处理跨服社交论坛相关业务
开发:李伟
*/
func NewModule() core.IModule {
	m := new(Forum)
	return m
}

type Forum struct {
	modules.ModuleBase
	api_comp   *apiComp
	configure  *configureComp
	modelForum *modelForumComp
}

//模块名
func (this *Forum) GetType() core.M_Modules {
	return comm.ModuleEquipment
}

//模块初始化接口 注册用户创建角色事件
func (this *Forum) Init(service core.IService, module core.IModule, options core.IModuleOptions) (err error) {
	err = this.ModuleBase.Init(service, module, options)
	return
}

//装备组件
func (this *Forum) OnInstallComp() {
	this.ModuleBase.OnInstallComp()
	this.api_comp = this.RegisterComp(new(apiComp)).(*apiComp)
	this.modelForum = this.RegisterComp(new(modelForumComp)).(*modelForumComp)
	this.configure = this.RegisterComp(new(configureComp)).(*configureComp)
}
