package friend

import (
	"go_dreamfactory/comm"
	"go_dreamfactory/pb"
)

func (this *apiComp) SearchCheck(session comm.IUserSession, req *pb.FriendSearchReq) (chk map[string]interface{}, code comm.ErrorCode) {
	if req.NickName == "" {
		code = comm.ErrorCode{Code: pb.ErrorCode_FriendSearchNameEmpty}
		return
	}
	return
}

//搜索
func (this *apiComp) Search(session comm.IUserSession, chk map[string]interface{}, req *pb.FriendSearchReq) (code pb.ErrorCode) {
	var (
		rsp    *pb.FriendSearchRsp
		friend *pb.FriendBase
	)
	defer func() {
		if code == pb.ErrorCode_Success {
			rsp = &pb.FriendSearchRsp{
				Friend: friend,
			}
		}
		session.SendMsg(string(this.module.GetType()), FriendSubTypeSearch, rsp)
	}()

	user := this.module.modelFriend.Frined_FindCond(req.NickName)
	if user != nil {
		friend = &pb.FriendBase{
			UserId:   user.Uid,
			NickName: user.Name,
		}
	}
	return
}
