package hero

import (
	"go_dreamfactory/comm"
	"go_dreamfactory/lego/sys/log"
	"go_dreamfactory/pb"
	"go_dreamfactory/utils"
)

func (this *apiComp) ChoukaCheck(session comm.IUserSession, req *pb.HeroChoukaReq) (result map[string]interface{}, code comm.ErrorCode) {
	result = make(map[string]interface{})
	return
}

//抽卡
func (this *apiComp) Chouka(session comm.IUserSession, result map[string]interface{}, req *pb.HeroChoukaReq) (code pb.ErrorCode) {
	rsp := &pb.HeroChoukaResp{}

	defer func() {
		err := session.SendMsg(string(this.moduleHero.GetType()), HeroSubTypeChouka, rsp)
		if err != nil {
			code = pb.ErrorCode_SystemError
			return
		}
		utils.TraceFunc(session.GetUserId(), string(this.moduleHero.GetType()), HeroSubTypeChouka, req, rsp)
	}()

	heroCfgIds := []int32{15001, 25001}
	if err := this.moduleHero.modelHero.createMultiHero(session.GetUserId(), heroCfgIds...); err != nil {
		code = pb.ErrorCode_HeroCreate
		return
	}

	heroes, err := this.moduleHero.modelHero.getHeroList(session.GetUserId())
	if err != nil {
		log.Errorf("%v", err)
		code = pb.ErrorCode_DBError
		return
	}
	rsp.Heroes = heroes
	return
}
