package hero

import (
	"go_dreamfactory/comm"
	"go_dreamfactory/pb"
	"go_dreamfactory/utils"
)

//参数校验
func (this *apiComp) InfoCheck(session comm.IUserSession, req *pb.HeroInfoReq) (result map[string]interface{}, code comm.ErrorCode) {
	result = map[string]interface{}{}
	hero := this.moduleHero.modelHero.getOneHero(session.GetUserId(), req.HeroId)
	if hero == nil {
		code = comm.ErrorCode{Code: pb.ErrorCode_HeroNoExist}
	}
	result["hero"] = hero
	return
}

func (this *apiComp) Info(session comm.IUserSession, result map[string]interface{}, req *pb.HeroInfoReq) (code pb.ErrorCode) {
	rsp := &pb.HeroInfoRsp{}
	defer func() {
		err := session.SendMsg(string(this.moduleHero.GetType()), HeroSubTypeInfo, rsp)
		if err != nil {
			code = pb.ErrorCode_SystemError
			return
		}
		utils.TraceFunc(session.GetUserId(), string(this.moduleHero.GetType()), HeroSubTypeList, req, rsp)
	}()

	if v, ok := result["hero"]; ok {
		rsp.Base = v.(*pb.DBHero)
	}
	return
}
