package mail

import (
	"go_dreamfactory/comm"
	"go_dreamfactory/lego/sys/log"
	"go_dreamfactory/pb"
)

//参数校验
func (this *apiComp) DelMailCheck(session comm.IUserSession, req *pb.MailDelMailReq) (result map[string]interface{}, code comm.ErrorCode) {
	return
}

// 删除邮件
func (this *apiComp) DelMail(session comm.IUserSession, agrs map[string]interface{}, req *pb.MailDelMailReq) (code pb.ErrorCode) {
	var err error
	mailinfo := make([]*pb.DBMailData, 0)
	defer func() {
		session.SendMsg(string(this.module.GetType()), DelUserMailResp, &pb.MailDelMailResp{Mail: mailinfo})
	}()
	if session.GetUserId() == "" {
		code = pb.ErrorCode_NoLogin
		return
	}
	bRet := this.module.modelMail.Mail_DelUserMail(req.ObjID)
	if !bRet {
		code = pb.ErrorCode_DBError
		return
	}

	if mailinfo, err = this.module.modelMail.Mail_QueryUserMail(session.GetUserId()); err != nil {
		log.Errorf("QueryUserMailResp err:%v", err)
		code = pb.ErrorCode_CacheReadError
		return
	}

	return
}
