package mail

import (
	"go_dreamfactory/comm"
	"go_dreamfactory/pb"
)

func (this *apiComp) ReadMailCheck(session comm.IUserSession, req *pb.MailReadMailReq) (result map[string]interface{}, code comm.ErrorCode) {
	return
}

// 查看某一封邮件
func (this *apiComp) ReadMail(session comm.IUserSession, agrs map[string]interface{}, req *pb.MailReadMailReq) (code pb.ErrorCode) {
	var (
		err  error
		mail *pb.DBMailData
	)
	defer func() {
		session.SendMsg(string(this.module.GetType()), ReadUserMailResp, &pb.MailReadMailResp{Mail: mail})
	}()
	if session.GetUserId() == "" {
		code = pb.ErrorCode_NoLogin
		return
	}

	mail, err = this.module.modelMail.Mail_ReadOneMail(req.ObjID)
	if err != nil {
		code = pb.ErrorCode_ReqParameterError
	}

	return
}
