package pb

var ErrorCodeMsg = map[ErrorCode]string{
	ErrorCode_Success:                 "成功",
	ErrorCode_NoFindService:           "没有找到远程服务器",
	ErrorCode_RpcFuncExecutionError:   "Rpc方法执行错误",
	ErrorCode_CacheReadError:          "缓存读取失败",
	ErrorCode_SqlExecutionError:       "数据库执行错误",
	ErrorCode_ReqParameterError:       "请求参数错误",
	ErrorCode_SignError:               "签名错误",
	ErrorCode_InsufficientPermissions: "权限不足",
	ErrorCode_NoLogin:                 "未登录",
	ErrorCode_UserSessionNobeing:      "用户不存在",
}

func GetErrorCodeMsg(code ErrorCode) string {
	if v, ok := ErrorCodeMsg[code]; ok {
		return v
	} else {
		return "未描述"
	}
}
