package cache

import "go_dreamfactory/lego/sys/redis"

/*
redis 缓存数据管理系统
*/

type (
	ISys interface {
		Redis() redis.ISys
	}
)

const ()

//全局使用的系统对象
var Defsys ISys

//初始化缓存系统
func OnInit(config map[string]interface{}, option ...Option) (err error) {
	var options Options
	if options, err = newOptions(config, option...); err != nil {
		return
	}
	Defsys, err = newSys(options)
	return
}

//系统实例化接口       每个系统默认都会提供全局以及实例化的接口
func NewSys(option ...Option) (sys ISys, err error) {
	var options Options
	if options, err = newOptionsByOption(option...); err != nil {
		return
	}
	Defsys, err = newSys(options)
	return
}

//系统实例化接口       每个系统默认都会提供全局以及实例化的接口
func Redis() redis.ISys {
	return Defsys.Redis()
}
