package db

import "go_dreamfactory/lego/sys/mgo"

type (
	ISys interface {
		Mgo() mgo.ISys
	}
)

var Defsys ISys

func OnInit(config map[string]interface{}, option ...Option) (err error) {
	var options Options
	if options, err = newOptions(config, option...); err != nil {
		return
	}
	Defsys, err = newSys(options)
	return
}

func NewSys(option ...Option) (sys ISys, err error) {
	var options Options
	if options, err = newOptionsByOption(option...); err != nil {
		return
	}
	Defsys, err = newSys(options)
	return
}

func Mgo() mgo.ISys {
	return Defsys.Mgo()
}
