package db

import (
	"go_dreamfactory/lego/core"
	"go_dreamfactory/lego/sys/mgo"
)

func newSys(options Options) (sys *DB, err error) {
	sys = &DB{options: options}
	err = sys.init()
	return
}

type DB struct {
	options Options
	mgo     mgo.ISys
}

func (this *DB) init() (err error) {
	if this.mgo, err = mgo.NewSys(
		mgo.SetMongodbUrl(this.options.MongodbUrl),
		mgo.SetMongodbDatabase(this.options.MongodbDatabase),
	); err != nil {
		return
	}
	return
}

func (this *DB) Mgo() mgo.ISys {
	return this.mgo
}

func (this *DB) Table(tableName string) *DB {
	this.mgo.Collection(core.SqlTable(tableName)).Database()
	return this
}
